@echo off
rem .......................................................................
rem     c't Offline-Update 2.11                   mailto: kav@ctmagazin.de
rem                                 Autoren: Harald Hothan, Karsten Violka
rem .......................................................................

title c't Offline-Update 2.11
setlocal
set debug=

rem ein paar Informationen in die Logdatei schreiben
echo --------------------------------------------------------------------- >> %systemdrive%\update.log
echo %date% %time% - START - %~df0 >> %systemdrive%\update.log

if "%1"=="" goto noargs
if "%1"=="-debug" (
	set debug=true
	rem ein paar Informationen in die Logdatei schreiben
	echo %date% %time% - INFO - Debug-Modus eingeschaltet >> %systemdrive%\update.log
) else (
	echo Optionen: update.cmd [-debug]
	rem ein paar Informationen in die Logdatei schreiben
	echo %date% %time% - FEHLER - unbekannter Befehlszeilenparameter >> %systemdrive%\update.log
	goto end
)

:noargs

echo ....................................................................
echo ... c't Offline-Update 2.11 ........................... Apr 2005 ...
echo ... Windows XP/2000 ........................... kav@ctmagazin.de ...
echo ....................................................................

call :getOS
if not %BS%==W2K (
	if not %BS%==XP goto unsupported
)

set isadmin=
call :checkAdmin
if not "%isadmin%"=="y" (
	echo.
	echo Sie bentigen Administratorrechte, um die Updates zu installieren.
	rem ein paar Informationen in die Logdatei schreiben
	echo %date% %time% - FEHLER - keine Administratorrechte vorhanden >> %systemdrive%\update.log
	goto :end
)

call :getSPVersion

echo Betriebssystem: %BS%
echo SP: '%SPVersion%'

rem ein paar Informationen in die Logdatei schreiben
echo %date% %time% - INFO - Windows: %BS% - SP: %SPVersion% >> %systemdrive%\update.log

if %BS%==XP goto winxp

rem ----- Windows 2000 ---------------------------------------------------
if "%SPVersion%"=="Service Pack 4" goto win2kpostsp4
call skripte\update_sp.cmd
goto reboot

:win2kpostsp4
call :getIEVersion
if "%IEVersion%"=="62800.1106" goto win2kwie6

call skripte\update_ie6sp1.cmd
goto reboot

:win2kwie6
call skripte\update_w2k_post_sp4.cmd
goto reboot

rem ----- Windows XP -----------------------------------------------------
:winxp
if "%SPVersion%"=="Service Pack 2" goto winxppostsp2
call skripte\update_sp.cmd
goto reboot

:winxppostsp2
call skripte\update_xp_post_sp2.cmd
goto reboot

rem  ----- Neustart ------------------------------------------------------
:reboot
rem 9059 = Datei nicht gefunden

if errorlevel 9059 goto end

:question
rem Wenn keine Nachfrage erfolgen soll einfach das rem vor einer
rem der folgenden beiden Zeilen entfernen:
rem goto autoreboot
rem goto end

echo.
SET /P qreboot=Jetzt neu starten, um die Updates zu aktivieren? [j/n]: 
IF /I '%qreboot%'=='J' GOTO autoreboot
IF /I '%qreboot%'=='N' GOTO end
GOTO question

:autoreboot
echo Der Computer wird in 15 Sekunden neu gestartet
if %BS%==XP goto rebootxp

if not exist tools\psshutdown.exe goto end
tools\psshutdown.exe -r -t 15
goto end

:rebootxp
shutdown -r -f -t 15 -d up:125:1
goto end

rem ----- Betriebssystem ermitteln ---------------------------------------
:getOS
ver | %systemroot%\system32\find "Windows 2000" >nul
if not errorlevel 1 (
	set BS=W2K
)

ver | %systemroot%\system32\find "Windows XP" >nul
if not errorlevel 1 (
	set BS=XP
)
goto :eof

rem ----- Administratorrechte prfen -------------------------------------
:checkAdmin
net localgroup administratoren | more +6 | find /i "%username%" >nul
if not errorlevel 1 set isadmin=y
goto :eof

REM ----- Service Pack ermitteln -----------------------------------------
:getSPVersion

REM ----- Registry-Schlssel in temporre Datei schreiben
regedit /e "%temp%\update.tmp" "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows NT\CurrentVersion"

REM ----- Versionsnummer des Service Packs auslesen
for /f "tokens=2 delims==" %%a in ('%systemroot%\system32\find "CSDVersion" "%temp%\update.tmp"') do (
  set SPVersion=%%a
  goto forexit
)
:forexit
for /f "tokens=1 delims=" %%a in (%SPVersion%) do set SPVersion=%%a
goto :eof

REM ----- IE-Version ermitteln -------------------------------------------
:getIEVersion
rem Registry Key in temporre Datei schreiben
regedit /e "%temp%\update.tmp" "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Internet Explorer"

rem Versionsnummer aus der temporren Datei auslesen
for /f "tokens=2 delims==" %%a in ('%systemroot%\system32\find /n "Build" "%temp%\update.tmp"') do set IEVersion=%%a
for /f "tokens=1 delims=" %%a in (%IEVersion%) do set IEVersion=%%a
goto :eof

rem -----------------------------------------------------------------------
:unsupported
echo Diese Windows-Version wird nicht untersttzt.
echo.

:end
rem Aufrumen
if exist "%temp%\update.tmp" del "%temp%\update.tmp"
echo.
rem ein paar Informationen in die Logdatei schreiben
echo %date% %time% - ENDE - %~df0 >> %systemdrive%\update.log
pause

